#ifndef _list_h
#define _list_h

#include "element.h"

struct ListNode;

typedef struct ListNode *List;
typedef struct ListNode *Position;

/* Implement the following functions */

List CreateList(void);		/* aka MakeEmpty */
void ClearList(List L);		/* aka DeleteList */

void PrintList(List L, ElementPrintLabel P);
int CountListEntries(List L);

Position InsertListEntry(List L, Position P, ElementType X);

int ListIsEmpty(List L);
Position GetFirstListEntry(List L);
Position AdvanceListEntry(Position P);
ElementType GetListEntryElement(Position P);
int ListEntryIsLast(List L,Position P);

/* Do not implement these functions */

List *CreateListArray(int n);
Position FindListEntry(List L, ElementType X, Comparator C);
Position FindPreviousListEntry(List L,ElementType X,Comparator C);
void DeleteListEntry(List L, Position P);

#endif /* _list_h */
